<p align="center">

<img  src="https://mk0abtastybwtpirqi5t.kinstacdn.com/wp-content/uploads/picture-solutions-persona-product-flagship.jpg"  width="211"  height="182"  alt="flagship-java"  />

</p>

[![CI](https://github.com/flagship-io/flagship-flutter-sdk/actions/workflows/ci.yml/badge.svg?branch=main)](https://github.com/flagship-io/flagship-flutter-sdk/actions/workflows/ci.yml)
[![codecov](https://codecov.io/gh/flagship-io/flagship-flutter-sdk/branch/main/graph/badge.svg?token=JXtwVuCj3s)](https://codecov.io/gh/flagship-io/flagship-flutter-sdk)
[![Pub Version](https://img.shields.io/pub/v/flagship)](https://pub.dev/packages/flagship)

<h3 align="center">Bring your features to life</h3>

**Visit [https://developers.flagship.io/](https://developers.flagship.io/) to get started with Flagship.**

## Docs

- [Get Started](https://docs.developers.flagship.io/docs/flutter-v20x#getting-started)
- [Initialize and start](https://docs.developers.flagship.io/docs/flutter-v20x#initialization)
- [Campaign integration](https://docs.developers.flagship.io/docs/flutter-v20x#managing-visitor-campaigns)
- [Hit tracking](https://docs.developers.flagship.io/docs/flutter-v20x#hit-tracking)
- [Release Notes](https://docs.developers.flagship.io/docs/flutter-sdk)

## Contributors

 - Adel FERGUEN [@ABTastyAdel](https://github.com/ABTastyAdel)
 - Guillaume Jacquart [@guillaumejacquart](https://github.com/guillaumejacquart)

## Licence

[Apache License.](https://github.com/flagship-io/flagship-java/blob/master/LICENSE)


## About Flagship
​
<img src="https://www.flagship.io/wp-content/uploads/Flagship-horizontal-black-wake-AB.png" alt="drawing" width="150"/>
​
[Flagship by AB Tasty](https://www.flagship.io/) is a feature flagging platform for modern engineering and product teams. It eliminates the risks of future releases by separating code deployments from these releases :bulb: With Flagship, you have full control over the release process. You can:
​
- Switch features on or off through remote config.
- Automatically roll-out your features gradually to monitor performance and gather feedback from your most relevant users.
- Roll back any feature should any issues arise while testing in production.
- Segment users by granting access to a feature based on certain user attributes.
- Carry out A/B tests by easily assigning feature variations to groups of users.
​
<img src="https://www.flagship.io/wp-content/uploads/demo-setup.png" alt="drawing" width="600"/>


​
**To learn more:**
​
- [Solution overview](https://www.flagship.io/#showvideo) - A 5mn video demo :movie_camera:
- [Documentation](https://docs.developers.flagship.io/) - Our dev portal with guides, how tos, API and SDK references
- [Sign up for a free trial](https://www.flagship.io/sign-up/) - Create your free account
- [Guide to feature flagging](https://www.flagship.io/feature-flags/) - Everyhting you need to know about feature flag related use cases
- [Blog](https://www.flagship.io/blog/) - Additional resources about release management
